#!/bin/bash

###########################################################################################
#	run.ring
#		version: 	0.1	13/10/09
#
#		original author:	Michele Bracuto		<bracuto@cs.unibo.it>
#		modified by:		Gabriele D'Angelo	<gda@cs.unibo.it>
#
#	description:
#		executes the JTS_ring (Java TimeStepped Ring) simulation
#
#	usage:	
#		./run.ring <#LP> 
#	
#		mandatory input parameters = #LP
#		#LP = 	number of Logical Processes to simulate
#
#		example: ./run.ring 10
#			it runs a parallel simulation composed of 10 LPs
#
###########################################################################################

HOST="localhost"

if [ "$#" != "1" ]; then
        echo "USAGE: $0  [#LP]"
        echo ""
        exit
fi

echo "Starting SIMA $1  ... "
./sima $1 &

X=0
while [ $X -lt $1 ]
do
	echo "Starting $X ... "
	time java JTS_ring $X $1 > $X.out 2> $X.err &

        X=$((X+1))
done
