#ifndef  __LPINFO_H_
#define  __LPINFO_H_


#define MAX_LP		1024
#define MAX_LOCAL_LP	64	
#define MAX_HOSTNAMELEN	64


#define IOVEC_DIM 	4096


/* Message Header */
typedef struct {
	#ifdef	USE_MARSHALLING
	char	type;
	#endif

	#ifdef CLONING
	short	cid;
	#endif

	short	lp;
	int	size;		// fixed by gda, it was short
} RawHdr;


/* Channel Type */
typedef enum {
	IN,
	OUT,
	BOTH,
	LOCAL,
	CLOSED
} ChannelType;


/* Protocol Type */
typedef enum {
	TCP,
	SHM,
	MPI
} ProtocolType;


/* LP Structure */
typedef struct
{
	int	type;		/* Channel Type	  		  */
	int	protocol;	/* Communication Protocol	  */
	int  	nodeid;		/* LP Identifier		  */
	int  	gnodeid;	/* Group Identifier (SHM and MPI) */
	int  	port;		/* TCP Port 			  */
	int 	sockfd;		/* File Descriptor		  */
	double	lookahead;	/* Outgoing Lookahead		  */
	char 	hostname[MAX_HOSTNAMELEN];  /* LP Hostname	  */
	char 	cname[MAX_HOSTNAMELEN];	    /* LP Canonical Name  */
} LPInfo;
/*---------------------------------------------------------------------------*/

#endif /* __LPINFO_H_  */
