#ifndef __RTICOMM_H_
#define __RTICOMM_H_


#include <sys/uio.h>


typedef LPInfo  LPStruct;
extern	int  	COMM_nodeid, COMM_numnodes;
typedef void 	COMM_handler( int, int );
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*                             RTICOMM API                                      */
/*---------------------------------------------------------------------------*/
void	COMM_Initialize( char *, COMM_handler *, char *, int );
void	COMM_Finalize(  );
int	COMM_Send( int, void *, int );
int	COMM_SendV( int, const struct iovec *, int );
int	COMM_Receive( int, void *, int );

void	COMM_Lock();
void	COMM_UnLock();
void	COMM_Wait( );
void	COMM_Barrier( );

int	COMM_GetDebug( );
void	COMM_SetDebug( int );

LPStruct *COMM_Find_LPid( int );
LPStruct *COMM_Find_LP_byName( char *);

int	COMM_SendToSIMA(void *, int);
int	COMM_ReceiveFromSIMA(void *, int);

#ifdef CLONING
int 	COMM_Clone( int, int );
#endif
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*                              SIMA API                                     */
/*---------------------------------------------------------------------------*/
void	SIMA_Initialize( int , int , char * );
void 	SIMA_Finalize( void );
void	SIMA_Barrier( );
int 	SIMA_GetPeerSocket( int  );
int 	SIMA_SendToAll( void *, int  );
int 	SIMA_SendTo( int, void *, int  );
int 	SIMA_ReceiveFromAll( void *, int  );
LPInfo *SIMA_GetPeerInfo( int  );
/*---------------------------------------------------------------------------*/



#endif /* __RTICOMM_H_ */

