#ifndef __TS_H
#define __TS_H

#include <sys/uio.h>

#define MAX_ERROR_STRING  256


typedef double 		TM_Time;


int	TS_Init(char *, char *, int );
int	TS_Send(int, TM_Time, void *, int );
int	TS_SendPrio(int, TM_Time, void *, int, int );
int 	TS_Broadcast(TM_Time, void *, int );
int 	TS_BroadcastPrio(TM_Time, void *, int, int );
int 	TS_SendToOthers(TM_Time, void *, int );
int 	TS_Schedule(TM_Time, void *, int );
//
int	TS_SendV(int, TM_Time, struct iovec *, int, int );
int 	TS_BroadcastV(TM_Time, struct iovec *, int );
int 	TS_SendToOthersV(TM_Time, struct iovec *, int );
int 	TS_ScheduleV(TM_Time, struct iovec *, int );
//
long 	TS_Receive(int *, TM_Time *, void *, int );
long	TS_ReceiveV(int *, TM_Time *, struct iovec * );

void	TS_SetLpAlive(int, int );

TM_Time TS_TimeAdvance();
TM_Time TS_GetStep();
TM_Time TS_SetStep(TM_Time);	//Beta 
void 	TS_Finalize();
int	TS_SendToSIMA(void *, int );
int	TS_ReceiveFromSIMA(void *, int );

int	TS_Clone();

#endif /*__TS_H*/
