#ifndef __ARTIS_H
#define __ARTIS_H


#define MAX_ERROR_STRING  256
typedef double 		TM_Time;
/* ---------------------------------------------------------- */



/*** TimeStepped ***/
int	TS_Init(char *, char *, int );
int	TS_Send(int, TM_Time, void *, int );
int 	TS_Broadcast(TM_Time, void *, int );
int 	TS_SendToOthers(TM_Time, void *, int );
int 	TS_Schedule(TM_Time, void *, int );
long 	TS_Receive(int *, TM_Time *, void *, int );
TM_Time TS_TimeAdvance();
TM_Time TS_GetStep();
void 	TS_Finalize();
int	TS_SendToSIMA(void *, int );
int	TS_ReceiveFromSIMA(void *, int );
/* ---------------------------------------------------------- */


/*** CMB ***/
int	CMB_Init( char *, char *, int );
int	CMB_Send( int, TM_Time, void *, int );
int 	CMB_Broadcast( TM_Time, void *, int );
int 	CMB_SendToOthers( TM_Time, void *, int );
int 	CMB_Schedule( TM_Time, void *, int );
long 	CMB_Receive( int *, TM_Time *, void *, int );
TM_Time	CMB_SetLookAhead( int, TM_Time );
TM_Time CMB_GetLookAhead( int );
void 	CMB_Finalize( );
/* ---------------------------------------------------------- */



/*** GAIA ***/
int	GAIA_Initialize (int, int, char *, char *, char *, int );
void	GAIA_Finalize ( );
void	GAIA_SetFstID (int );
void	GAIA_SetHistory ( int );
void	GAIA_SetMF ( float );
void	GAIA_SetMT ( unsigned int );
void	GAIA_SetCountDown ( int );
void	GAIA_SetHistorySlots ( int );
void	GAIA_SetEventHistorySize (int );
void	GAIA_SetMigration ( int );
void	GAIA_SetLoadBalancing (int );
void	GAIA_GetStatistics ( int *, int *, int * );
TM_Time	GAIA_GetStep ( );
int	GAIA_Register ( int );
TM_Time	GAIA_TimeAdvance ();
void	GAIA_Migrate (int, void *, int );
void	GAIA_Send (int, int, TM_Time, void *, int );
void	GAIA_Broadcast (int, TM_Time, void *, int );
char	GAIA_Receive(int *, int *, TM_Time *, void *, int *);
/* ---------------------------------------------------------- */



#endif /*__ARTIS_H*/
