//import java.util.*;

public class ARTISjava {
	// Native method declarations
	

	// cmb.h
	//
	// 	int     CMB_Init( char *, char *, int );
	// 	int     CMB_Send( int, TM_Time, void *, int );
	// 	int     CMB_Broadcast( TM_Time, void *, int );
	// 	int     CMB_SendToOthers( TM_Time, void *, int );
	// 	int     CMB_Schedule( TM_Time, void *, int );
	// 	long    CMB_Receive( int *, TM_Time *, void *, int );
	// 	TM_Time CMB_SetLookAhead( int, TM_Time );
	// 	TM_Time CMB_GetLookAhead( int );
	// 	void    CMB_Finalize( );
	
	native	int CMB_Init(String cname, String sima_host_name, int sima_port);  
	native	int CMB_Send(int lp, double Ts, String Msg, int Size);
	native	int CMB_Broadcast(double Ts, String Msg, int Size);
	native	int CMB_SendToOthers(double Ts, String Msg, int Size);
	native	int CMB_Schedule(double Ts, String Msg, int Size);
	native	String CMB_Receive(int maxlen);
	native	double CMB_SetLookAhead(int lp, double NewLA);
	native	int CMB_GetLookAhead(int lp);
	native	void CMB_Finalize();
	


	// ts.h
	//
	//	int     TS_Init(char *, char *, int );
	//	int     TS_Send(int, TM_Time, void *, int );
	//	int     TS_Broadcast(TM_Time, void *, int );
	//	int     TS_SendToOthers(TM_Time, void *, int );
	//	int     TS_Schedule(TM_Time, void *, int );
	//	long    TS_Receive(int *, TM_Time *, void *, int );
	//	TM_Time TS_TimeAdvance();
	//	TM_Time TS_GetStep();
	//	void    TS_Finalize();
	
	native	int TS_Init(String cname, String sima_host_name, int sima_port);
	native	int TS_Send(int lp, double Ts, String Msg, int Size);
	native	int TS_Broadcast(double Ts, String Msg, int Size);
	native	int TS_SendToOthers(double Ts, String Msg, int Size);
	native	int TS_Schedule(double Ts, String Msg, int Size);
	native	String TS_Receive(int maxlen);
	native	double TS_TimeAdvance();
	native	double TS_GetStep();
	native	void TS_Finalize();
	
	


	// GAIA.h
	//
	// 	int	GAIA_Initialize (int, int, char *, char *, char *, int );
	// 	void	GAIA_Finalize ( );
	// 	void	GAIA_SetFstID (int );
	// 	void	GAIA_SetMF (int );
	// 	void	GAIA_SetMigration (int );
	// 	void	GAIA_SetLoadBalancing (int );
	// 	double	GAIA_GetStep ( );
	// 	int	GAIA_Register ( );
	// 	double	GAIA_TimeAdvance ();
	// 	void	GAIA_Migrate (int, void *, int );
	// 	void	GAIA_Send (int, int, TM_Time, void *, int );
	// 	void	GAIA_Broadcast (int, TM_Time, void *, int );
	// 	char	GAIA_Receive(int *, int *, TM_Time *, void *, int );



	native	int	GAIA_Initialize (int max_objs_count, int nlp, String RandFile, String cname, String sima_host_name, int sima_port);
	native	void	GAIA_Finalize ( );
	native	void	GAIA_SetFstID (int first_id);
	native	void	GAIA_SetHistory ( int new_size);
	native	void	GAIA_SetMF (float migr_factor);
	native  void 	GAIA_SetMT (int migr_threshold);
	native	void	GAIA_SetMigration (int state);
	native	void	GAIA_SetCountDown ( int countdown);
	native	void	GAIA_SetHistorySlots ( int slots);
	native	void	GAIA_SetEventHistorySize (int size);
	native	void	GAIA_SetLoadBalancing (int state);
	native	double	GAIA_GetStep ( );
	native	int	GAIA_Register (int migrable);
	native	double	GAIA_TimeAdvance ();
	native	void	GAIA_GetStatistics ();
	native	void	GAIA_Migrate (int id, String data, int size );
	native	void	GAIA_ByteMigrate (int id, byte[] data, int size );
	native	void	GAIA_Send (int obj_src, int obj_dest, double Ts, String Msg, int Size); 
	native	void	GAIA_ByteSend (int obj_src, int obj_dest, double Ts, byte[] Msg, int Size);
	native	void	GAIA_Broadcast (int obj_src, double Ts, String Msg, int Size);
	native	void	GAIA_ByteBroadcast (int obj_src, double Ts, byte[] Msg, int Size);
	native	String	GAIA_Receive(int maxlen);
	native	byte[]	GAIA_ByteReceive(int maxlen);

	// Define GAIA
	public static final int MIGRABLE	= 1;
	public static final int NOT_MIGRABLE	= 0;
	public static final int UNSET		= 'U';
	public static final int EOS		= 'E';	// End Of Step
	public static final int NOTIF_MIGR	= 'N';
	public static final int NOTIF_MIGR_EXT	= 'n';
	public static final int EXEC_MIGR	= 'M';
	public static final int REGISTER	= 'R';
	public static final int	 MIGR_OFF 	= 0;
	public static final int	 MIGR_ON	= 1;
	public static final int	 MIGR_E1	= 1;
	public static final int	 MIGR_E2 	= 2;
	public static final int	 MIGR_E3 	= 3;
	public static final int	 LOAD_ON	= 1;
	public static final int	 LOAD_OFF 	= 0;



	// GAIA
	static	int	to;
	static	int	type;

	// GAIA statistics
	static	int	local;
	static	int	remote;
	static	int	migrations;

	// ARTIS
	static	int	LP_ID;
	static	int	from;
	static	int	ready;
	static	double	Ts;


	// Load the library
	static { System.loadLibrary("artisjava"); }
}
