/*	##############################################################################################
	Advanced RTI System, ARTÌS			http://pads.cs.unibo.it

	Description:
		-	model level simulation hard coded simulation parameters
		-	uncomment DEBUG for very verbose output

	Authors:
		First version by Gabriele D'Angelo <gda@cs.unibo.it>

	############################################################################################### */

// Uncomment to activate debug
//#define DEBUG

// Simulation length (final clock value)
#define END_CLOCK			1000.0

// Number of timestep required by ping messages to receive the destination node
//	WARNING: due to synchronization constraints The FLIGHT_TIME has to be bigger 
//		than the timestep size
#define FLIGHT_TIME			1.0

// Max number of records that can be inserted in a single ping message
#define	MAX_PING_DYNAMIC_RECORDS	15

// Max number of records that can be inserted in a single migration message
#define	MAX_MIGRATION_DYNAMIC_RECORDS	10

// Buffer size for incoming messages
//	obviously the buffer needs to be so large to contain all kind of messages
//	(e.g. ping and migration messages)
#define BUFFER_SIZE			65535

